/*##############################################################################

    HPCC SYSTEMS software Copyright (C) 2012 HPCC Systems.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
############################################################################## */

// IMPORTANT: this test is generated by the perl script genjointest.pl, so do not edit it by hand
//nothor

#option('convertJoinToLookup', 0);
#option('noAllToLookupConversion', 1);
#option('spanMultipleCpp', 1);

jrec := RECORD,MAXLENGTH(100)
    UNSIGNED1 i;
    STRING3 lstr;
    STRING3 rstr;
    UNSIGNED1 c;
    STRING label;
END;

lhs := SORTED(DATASET([{3, 'aaa', '', 0, ''}, {4, 'bbb', '', 0, ''}, {5, 'ccc', '', 0, ''}, {6, 'ddd', '', 0, ''}, {7, 'eee', '', 0, ''}], jrec), i);
rhs := SORTED(DATASET([{1, '', 'fff', 0, ''}, {3, '', 'ggg', 0, ''}, {5, '', 'hhh', 0, ''}, {5, '', 'iii', 0, ''}, {5, '', 'xxx', 0, ''}, {5, '', 'jjj', 0, ''}, {7, '', 'kkk', 0, ''}, {9, '', 'lll', 0, ''}, {9, '', 'mmm', 0, ''}], jrec), i);

trueval := true : stored('trueval');
falseval := false : stored('falseval');
BOOLEAN match1(jrec l, jrec r) := (l.i = r.i);
BOOLEAN match2(jrec l, jrec r) := (r.rstr < 'x');
BOOLEAN match(jrec l, jrec r) := (match1(l, r) AND match2(l, r));
BOOLEAN allmatch1(jrec l, jrec r) := ((match1(l, r) AND trueval) OR falseval);
BOOLEAN allmatch(jrec l, jrec r) := (allmatch1(l, r) AND match2(l, r));

// transform for joins and non-group denormalizes, to be used with match or allmatch
jrec xfm(jrec l, jrec r, STRING lab) := TRANSFORM
    SELF.i := l.i;
    SELF.lstr := l.lstr;
    SELF.rstr := r.rstr;
    SELF.c := l.c+1;
    SELF.label := lab;
END;

// skipping transform for joins and non-group denormalizes
// when used with match1 or allmatch1, similar to the above, but remember that right outer picks up rows whose matches failed but not ones whose transforms skipped
jrec xfmskip(jrec l, jrec r, STRING lab) := TRANSFORM
    SELF.i := l.i;
    SELF.lstr := l.lstr;
    SELF.rstr := IF(r.rstr >= 'x', SKIP, r.rstr);
    SELF.c := l.c+1;
    SELF.label := lab;
END;

// transform for group denormalizes, to be used with match or allmatch
jrec xfmgrp(jrec l, DATASET(jrec) r, STRING lab) := TRANSFORM
    UNSIGNED c := COUNT(r);
    SELF.i := l.i;
    SELF.lstr := l.lstr;
    SELF.rstr := r[c].rstr;
    SELF.c := c;
    SELF.label := lab;
END;

// skipping transform for group denormalizes, to be used with match or allmatch
// used with match1 or allmatch1, but has a different behaviour because a skip on a group denormalize skips the whole group rather than just one row
jrec xfmgrpskip(jrec l, DATASET(jrec) r, STRING lab) := TRANSFORM
    UNSIGNED c := COUNT(r);
    UNSIGNED skp := COUNT(r(rstr >= 'x'));
    SELF.i := l.i;
    SELF.lstr := l.lstr;
    SELF.rstr := IF(skp > 0, SKIP, r[c].rstr);
    SELF.c := c;
    SELF.label := lab;
END;

deno____INN________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE'), INNER);
deno____INN____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_XFMSKIP'), INNER);
deno____INN_kp_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_KEEP'), INNER, KEEP(2));
deno____INN_kp_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_KEEP_XFMSKIP'), INNER, KEEP(2));
deno____INN_at_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_ATMOST'), INNER, ATMOST(match1(LEFT, RIGHT), 3));
deno____INN_at_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_ATMOST_XFMSKIP'), INNER, ATMOST(match1(LEFT, RIGHT), 3));
deno____INN_ls_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LIMITSKIP'), INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LIMITSKIP')));
deno____INN_ls_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LIMITSKIP_XFMSKIP'), INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LIMITSKIP_XFMSKIP')));
deno____INN_lo_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LIMITONFAIL'), INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LIMITONFAIL')));
deno____INN_lo_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LIMITONFAIL_XFMSKIP'), INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LIMITONFAIL_XFMSKIP')));
deno____INN_lf_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LIMITFAIL'), INNER, LIMIT(3));
deno____INN_lf_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LIMITFAIL_XFMSKIP'), INNER, LIMIT(3));
deno____LOU_at_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_ATMOST'), LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3));
deno____LOU_at_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_ATMOST_XFMSKIP'), LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3));
deno____LOU_ls_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_LIMITSKIP'), LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LEFT_OUTER_LIMITSKIP')));
deno____LOU_ls_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_LIMITSKIP_XFMSKIP'), LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LEFT_OUTER_LIMITSKIP_XFMSKIP')));
deno____LOU_lo_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_LIMITONFAIL'), LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LEFT_OUTER_LIMITONFAIL')));
deno____LOU_lo_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_LIMITONFAIL_XFMSKIP'), LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LEFT_OUTER_LIMITONFAIL_XFMSKIP')));
deno____LOU_lf_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_LIMITFAIL'), LEFT OUTER, LIMIT(3));
deno____LOU_lf_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_OUTER_LIMITFAIL_XFMSKIP'), LEFT OUTER, LIMIT(3));
deno____LON________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_ONLY'), LEFT ONLY);
deno____LON____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_ONLY_XFMSKIP'), LEFT ONLY);
deno____LON_at_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LEFT_ONLY_ATMOST'), LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3));
deno____LON_at_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LEFT_ONLY_ATMOST_XFMSKIP'), LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3));
deno____ROU________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER'), RIGHT OUTER);
deno____ROU____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_XFMSKIP'), RIGHT OUTER);
deno____ROU_ls_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_LIMITSKIP'), RIGHT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_RIGHT_OUTER_LIMITSKIP')));
deno____ROU_ls_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_LIMITSKIP_XFMSKIP'), RIGHT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_RIGHT_OUTER_LIMITSKIP_XFMSKIP')));
deno____ROU_lo_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_LIMITONFAIL'), RIGHT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_RIGHT_OUTER_LIMITONFAIL')));
deno____ROU_lo_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_LIMITONFAIL_XFMSKIP'), RIGHT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_RIGHT_OUTER_LIMITONFAIL_XFMSKIP')));
deno____ROU_lf_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_LIMITFAIL'), RIGHT OUTER, LIMIT(3));
deno____ROU_lf_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_RIGHT_OUTER_LIMITFAIL_XFMSKIP'), RIGHT OUTER, LIMIT(3));
deno____RON________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_RIGHT_ONLY'), RIGHT ONLY);
deno____RON____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_RIGHT_ONLY_XFMSKIP'), RIGHT ONLY);
deno____FOU________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER'), FULL OUTER);
deno____FOU____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_XFMSKIP'), FULL OUTER);
deno____FOU_ls_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_LIMITSKIP'), FULL OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_FULL_OUTER_LIMITSKIP')));
deno____FOU_ls_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_LIMITSKIP_XFMSKIP'), FULL OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_FULL_OUTER_LIMITSKIP_XFMSKIP')));
deno____FOU_lo_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_LIMITONFAIL'), FULL OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_FULL_OUTER_LIMITONFAIL')));
deno____FOU_lo_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_LIMITONFAIL_XFMSKIP'), FULL OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_FULL_OUTER_LIMITONFAIL_XFMSKIP')));
deno____FOU_lf_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_LIMITFAIL'), FULL OUTER, LIMIT(3));
deno____FOU_lf_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_FULL_OUTER_LIMITFAIL_XFMSKIP'), FULL OUTER, LIMIT(3));
deno____FON________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_FULL_ONLY'), FULL ONLY);
deno____FON____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_FULL_ONLY_XFMSKIP'), FULL ONLY);
deno_l1_INN________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP'), LOOKUP, INNER);
deno_l1_INN____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_XFMSKIP'), LOOKUP, INNER);
deno_l1_LOU________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_LEFT_OUTER'), LOOKUP, LEFT OUTER);
deno_l1_LOU____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_LEFT_OUTER_XFMSKIP'), LOOKUP, LEFT OUTER);
deno_l1_LON________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_LEFT_ONLY'), LOOKUP, LEFT ONLY);
deno_l1_LON____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_LEFT_ONLY_XFMSKIP'), LOOKUP, LEFT ONLY);
deno_lm_INN________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY'), LOOKUP, MANY, INNER);
deno_lm_INN____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_XFMSKIP'), LOOKUP, MANY, INNER);
deno_lm_INN_kp_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_KEEP'), LOOKUP, MANY, INNER, KEEP(2));
deno_lm_INN_kp_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_KEEP_XFMSKIP'), LOOKUP, MANY, INNER, KEEP(2));
deno_lm_INN_at_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_ATMOST'), LOOKUP, MANY, INNER, ATMOST(match1(LEFT, RIGHT), 3));
deno_lm_INN_at_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_ATMOST_XFMSKIP'), LOOKUP, MANY, INNER, ATMOST(match1(LEFT, RIGHT), 3));
deno_lm_INN_ls_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LIMITSKIP'), LOOKUP, MANY, INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LIMITSKIP')));
deno_lm_INN_ls_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LIMITSKIP_XFMSKIP'), LOOKUP, MANY, INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LIMITSKIP_XFMSKIP')));
deno_lm_INN_lo_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LIMITONFAIL'), LOOKUP, MANY, INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LIMITONFAIL')));
deno_lm_INN_lo_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LIMITONFAIL_XFMSKIP'), LOOKUP, MANY, INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LIMITONFAIL_XFMSKIP')));
deno_lm_INN_lf_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LIMITFAIL'), LOOKUP, MANY, INNER, LIMIT(3));
deno_lm_INN_lf_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LIMITFAIL_XFMSKIP'), LOOKUP, MANY, INNER, LIMIT(3));
deno_lm_LOU________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER'), LOOKUP, MANY, LEFT OUTER);
deno_lm_LOU____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_XFMSKIP'), LOOKUP, MANY, LEFT OUTER);
deno_lm_LOU_kp_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_KEEP'), LOOKUP, MANY, LEFT OUTER, KEEP(2));
deno_lm_LOU_kp_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_KEEP_XFMSKIP'), LOOKUP, MANY, LEFT OUTER, KEEP(2));
deno_lm_LOU_at_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_ATMOST'), LOOKUP, MANY, LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3));
deno_lm_LOU_at_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_ATMOST_XFMSKIP'), LOOKUP, MANY, LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3));
deno_lm_LOU_ls_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP'), LOOKUP, MANY, LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP')));
deno_lm_LOU_ls_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP'), LOOKUP, MANY, LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP')));
deno_lm_LOU_lo_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL')));
deno_lm_LOU_lo_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP')));
deno_lm_LOU_lf_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITFAIL'), LOOKUP, MANY, LEFT OUTER, LIMIT(3));
deno_lm_LOU_lf_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITFAIL_XFMSKIP'), LOOKUP, MANY, LEFT OUTER, LIMIT(3));
deno_lm_LON________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_ONLY'), LOOKUP, MANY, LEFT ONLY);
deno_lm_LON____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_XFMSKIP'), LOOKUP, MANY, LEFT ONLY);
deno_lm_LON_at_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_ATMOST'), LOOKUP, MANY, LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3));
deno_lm_LON_at_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_ATMOST_XFMSKIP'), LOOKUP, MANY, LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3));
deno_al_INN________ := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_ALL'), ALL, INNER);
deno_al_INN____xs__ := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_ALL_XFMSKIP'), ALL, INNER);
deno_al_INN_kp_____ := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_ALL_KEEP'), ALL, INNER, KEEP(2));
deno_al_INN_kp_xs__ := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_ALL_KEEP_XFMSKIP'), ALL, INNER, KEEP(2));
deno_al_LOU________ := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_ALL_LEFT_OUTER'), ALL, LEFT OUTER);
deno_al_LOU____xs__ := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_ALL_LEFT_OUTER_XFMSKIP'), ALL, LEFT OUTER);
deno_al_LOU_kp_____ := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_ALL_LEFT_OUTER_KEEP'), ALL, LEFT OUTER, KEEP(2));
deno_al_LOU_kp_xs__ := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_ALL_LEFT_OUTER_KEEP_XFMSKIP'), ALL, LEFT OUTER, KEEP(2));
deno_al_LON________ := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), xfm(LEFT, RIGHT, 'DENORMALIZE_ALL_LEFT_ONLY'), ALL, LEFT ONLY);
deno_al_LON____xs__ := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), xfmskip(LEFT, RIGHT, 'DENORMALIZE_ALL_LEFT_ONLY_XFMSKIP'), ALL, LEFT ONLY);
dngr____INN________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP'), INNER);
dngr____INN____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_XFMSKIP'), INNER);
dngr____INN_kp_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_KEEP'), INNER, KEEP(2));
dngr____INN_kp_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_KEEP_XFMSKIP'), INNER, KEEP(2));
dngr____INN_at_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ATMOST'), INNER, ATMOST(match1(LEFT, RIGHT), 3));
dngr____INN_at_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ATMOST_XFMSKIP'), INNER, ATMOST(match1(LEFT, RIGHT), 3));
dngr____INN_ls_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LIMITSKIP'), INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LIMITSKIP')));
dngr____INN_ls_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LIMITSKIP_XFMSKIP'), INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LIMITSKIP_XFMSKIP')));
dngr____INN_lo_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LIMITONFAIL'), INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LIMITONFAIL')));
dngr____INN_lo_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LIMITONFAIL_XFMSKIP'), INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LIMITONFAIL_XFMSKIP')));
dngr____INN_lf_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LIMITFAIL'), INNER, LIMIT(3));
dngr____INN_lf_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LIMITFAIL_XFMSKIP'), INNER, LIMIT(3));
dngr____LOU________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER'), LEFT OUTER);
dngr____LOU____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_XFMSKIP'), LEFT OUTER);
dngr____LOU_kp_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_KEEP'), LEFT OUTER, KEEP(2));
dngr____LOU_kp_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_KEEP_XFMSKIP'), LEFT OUTER, KEEP(2));
dngr____LOU_at_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_ATMOST'), LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3));
dngr____LOU_at_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_ATMOST_XFMSKIP'), LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3));
dngr____LOU_ls_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_LIMITSKIP'), LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LEFT_OUTER_LIMITSKIP')));
dngr____LOU_ls_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_LIMITSKIP_XFMSKIP'), LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LEFT_OUTER_LIMITSKIP_XFMSKIP')));
dngr____LOU_lo_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_LIMITONFAIL'), LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LEFT_OUTER_LIMITONFAIL')));
dngr____LOU_lo_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_LIMITONFAIL_XFMSKIP'), LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LEFT_OUTER_LIMITONFAIL_XFMSKIP')));
dngr____LOU_lf_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_LIMITFAIL'), LEFT OUTER, LIMIT(3));
dngr____LOU_lf_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_OUTER_LIMITFAIL_XFMSKIP'), LEFT OUTER, LIMIT(3));
dngr____LON________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_ONLY'), LEFT ONLY);
dngr____LON____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_ONLY_XFMSKIP'), LEFT ONLY);
dngr____LON_at_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_ONLY_ATMOST'), LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3));
dngr____LON_at_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LEFT_ONLY_ATMOST_XFMSKIP'), LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3));
dngr____ROU________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER'), RIGHT OUTER);
dngr____ROU____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_XFMSKIP'), RIGHT OUTER);
dngr____ROU_ls_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_LIMITSKIP'), RIGHT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_RIGHT_OUTER_LIMITSKIP')));
dngr____ROU_ls_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_LIMITSKIP_XFMSKIP'), RIGHT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_RIGHT_OUTER_LIMITSKIP_XFMSKIP')));
dngr____ROU_lo_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_LIMITONFAIL'), RIGHT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_RIGHT_OUTER_LIMITONFAIL')));
dngr____ROU_lo_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_LIMITONFAIL_XFMSKIP'), RIGHT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_RIGHT_OUTER_LIMITONFAIL_XFMSKIP')));
dngr____ROU_lf_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_LIMITFAIL'), RIGHT OUTER, LIMIT(3));
dngr____ROU_lf_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_OUTER_LIMITFAIL_XFMSKIP'), RIGHT OUTER, LIMIT(3));
dngr____RON________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_ONLY'), RIGHT ONLY);
dngr____RON____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_RIGHT_ONLY_XFMSKIP'), RIGHT ONLY);
dngr____FOU________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER'), FULL OUTER);
dngr____FOU____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_XFMSKIP'), FULL OUTER);
dngr____FOU_ls_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_LIMITSKIP'), FULL OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_FULL_OUTER_LIMITSKIP')));
dngr____FOU_ls_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_LIMITSKIP_XFMSKIP'), FULL OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_FULL_OUTER_LIMITSKIP_XFMSKIP')));
dngr____FOU_lo_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_LIMITONFAIL'), FULL OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_FULL_OUTER_LIMITONFAIL')));
dngr____FOU_lo_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_LIMITONFAIL_XFMSKIP'), FULL OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_FULL_OUTER_LIMITONFAIL_XFMSKIP')));
dngr____FOU_lf_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_LIMITFAIL'), FULL OUTER, LIMIT(3));
dngr____FOU_lf_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_OUTER_LIMITFAIL_XFMSKIP'), FULL OUTER, LIMIT(3));
dngr____FON________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_ONLY'), FULL ONLY);
dngr____FON____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_FULL_ONLY_XFMSKIP'), FULL ONLY);
dngr_l1_INN________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP'), LOOKUP, INNER);
dngr_l1_INN____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_XFMSKIP'), LOOKUP, INNER);
dngr_l1_LOU________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_LEFT_OUTER'), LOOKUP, LEFT OUTER);
dngr_l1_LOU____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_LEFT_OUTER_XFMSKIP'), LOOKUP, LEFT OUTER);
dngr_l1_LON________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_LEFT_ONLY'), LOOKUP, LEFT ONLY);
dngr_l1_LON____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_LEFT_ONLY_XFMSKIP'), LOOKUP, LEFT ONLY);
dngr_lm_INN________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY'), LOOKUP, MANY, INNER);
dngr_lm_INN____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_XFMSKIP'), LOOKUP, MANY, INNER);
dngr_lm_INN_kp_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_KEEP'), LOOKUP, MANY, INNER, KEEP(2));
dngr_lm_INN_kp_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_KEEP_XFMSKIP'), LOOKUP, MANY, INNER, KEEP(2));
dngr_lm_INN_at_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_ATMOST'), LOOKUP, MANY, INNER, ATMOST(match1(LEFT, RIGHT), 3));
dngr_lm_INN_at_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_ATMOST_XFMSKIP'), LOOKUP, MANY, INNER, ATMOST(match1(LEFT, RIGHT), 3));
dngr_lm_INN_ls_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LIMITSKIP'), LOOKUP, MANY, INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LIMITSKIP')));
dngr_lm_INN_ls_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LIMITSKIP_XFMSKIP'), LOOKUP, MANY, INNER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LIMITSKIP_XFMSKIP')));
dngr_lm_INN_lo_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LIMITONFAIL'), LOOKUP, MANY, INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LIMITONFAIL')));
dngr_lm_INN_lo_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LIMITONFAIL_XFMSKIP'), LOOKUP, MANY, INNER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LIMITONFAIL_XFMSKIP')));
dngr_lm_INN_lf_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LIMITFAIL'), LOOKUP, MANY, INNER, LIMIT(3));
dngr_lm_INN_lf_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LIMITFAIL_XFMSKIP'), LOOKUP, MANY, INNER, LIMIT(3));
dngr_lm_LOU________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER'), LOOKUP, MANY, LEFT OUTER);
dngr_lm_LOU____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_XFMSKIP'), LOOKUP, MANY, LEFT OUTER);
dngr_lm_LOU_kp_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_KEEP'), LOOKUP, MANY, LEFT OUTER, KEEP(2));
dngr_lm_LOU_kp_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_KEEP_XFMSKIP'), LOOKUP, MANY, LEFT OUTER, KEEP(2));
dngr_lm_LOU_at_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_ATMOST'), LOOKUP, MANY, LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3));
dngr_lm_LOU_at_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_ATMOST_XFMSKIP'), LOOKUP, MANY, LEFT OUTER, ATMOST(match1(LEFT, RIGHT), 3));
dngr_lm_LOU_ls_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP'), LOOKUP, MANY, LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP')));
dngr_lm_LOU_ls_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP'), LOOKUP, MANY, LEFT OUTER, LIMIT(3, SKIP), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP')));
dngr_lm_LOU_lo_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL')));
dngr_lm_LOU_lo_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP'), LOOKUP, MANY, LEFT OUTER, LIMIT(3), ONFAIL(xfm(LEFT, RIGHT, 'FAILED: DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP')));
dngr_lm_LOU_lf_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITFAIL'), LOOKUP, MANY, LEFT OUTER, LIMIT(3));
dngr_lm_LOU_lf_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITFAIL_XFMSKIP'), LOOKUP, MANY, LEFT OUTER, LIMIT(3));
dngr_lm_LON________ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY'), LOOKUP, MANY, LEFT ONLY);
dngr_lm_LON____xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_XFMSKIP'), LOOKUP, MANY, LEFT ONLY);
dngr_lm_LON_at_____ := DENORMALIZE(lhs, rhs, match(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_ATMOST'), LOOKUP, MANY, LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3));
dngr_lm_LON_at_xs__ := DENORMALIZE(lhs, rhs, match1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_ATMOST_XFMSKIP'), LOOKUP, MANY, LEFT ONLY, ATMOST(match1(LEFT, RIGHT), 3));
dngr_al_INN________ := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL'), ALL, INNER);
dngr_al_INN____xs__ := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_XFMSKIP'), ALL, INNER);
dngr_al_INN_kp_____ := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_KEEP'), ALL, INNER, KEEP(2));
dngr_al_INN_kp_xs__ := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_KEEP_XFMSKIP'), ALL, INNER, KEEP(2));
dngr_al_LOU________ := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_LEFT_OUTER'), ALL, LEFT OUTER);
dngr_al_LOU____xs__ := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_LEFT_OUTER_XFMSKIP'), ALL, LEFT OUTER);
dngr_al_LOU_kp_____ := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_LEFT_OUTER_KEEP'), ALL, LEFT OUTER, KEEP(2));
dngr_al_LOU_kp_xs__ := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_LEFT_OUTER_KEEP_XFMSKIP'), ALL, LEFT OUTER, KEEP(2));
dngr_al_LON________ := DENORMALIZE(lhs, rhs, allmatch(LEFT, RIGHT), GROUP, xfmgrp(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_LEFT_ONLY'), ALL, LEFT ONLY);
dngr_al_LON____xs__ := DENORMALIZE(lhs, rhs, allmatch1(LEFT, RIGHT), GROUP, xfmgrpskip(LEFT, ROWS(RIGHT), 'DENORMALIZEGROUP_ALL_LEFT_ONLY_XFMSKIP'), ALL, LEFT ONLY);

SEQUENTIAL(OUTPUT(deno____INN________, NAMED('DENORMALIZE')),
           OUTPUT(deno____INN____xs__, NAMED('DENORMALIZE_XFMSKIP')),
           OUTPUT(deno____INN_kp_____, NAMED('DENORMALIZE_KEEP')),
           OUTPUT(deno____INN_kp_xs__, NAMED('DENORMALIZE_KEEP_XFMSKIP')),
           OUTPUT(deno____INN_at_____, NAMED('DENORMALIZE_ATMOST')),
           OUTPUT(deno____INN_at_xs__, NAMED('DENORMALIZE_ATMOST_XFMSKIP')),
           OUTPUT(deno____INN_ls_____, NAMED('DENORMALIZE_LIMITSKIP')),
           OUTPUT(deno____INN_ls_xs__, NAMED('DENORMALIZE_LIMITSKIP_XFMSKIP')),
           OUTPUT(deno____INN_lo_____, NAMED('DENORMALIZE_LIMITONFAIL')),
           OUTPUT(deno____INN_lo_xs__, NAMED('DENORMALIZE_LIMITONFAIL_XFMSKIP')),
           OUTPUT(deno____LOU_at_____, NAMED('DENORMALIZE_LEFT_OUTER_ATMOST')),
           OUTPUT(deno____LOU_at_xs__, NAMED('DENORMALIZE_LEFT_OUTER_ATMOST_XFMSKIP')),
           OUTPUT(deno____LOU_ls_____, NAMED('DENORMALIZE_LEFT_OUTER_LIMITSKIP')),
           OUTPUT(deno____LOU_ls_xs__, NAMED('DENORMALIZE_LEFT_OUTER_LIMITSKIP_XFMSKIP')),
           OUTPUT(deno____LOU_lo_____, NAMED('DENORMALIZE_LEFT_OUTER_LIMITONFAIL')),
           OUTPUT(deno____LOU_lo_xs__, NAMED('DENORMALIZE_LEFT_OUTER_LIMITONFAIL_XFMSKIP')),
           OUTPUT(deno____LON________, NAMED('DENORMALIZE_LEFT_ONLY')),
           OUTPUT(deno____LON____xs__, NAMED('DENORMALIZE_LEFT_ONLY_XFMSKIP')),
           OUTPUT(deno____LON_at_____, NAMED('DENORMALIZE_LEFT_ONLY_ATMOST')),
           OUTPUT(deno____LON_at_xs__, NAMED('DENORMALIZE_LEFT_ONLY_ATMOST_XFMSKIP')),
           OUTPUT(deno____ROU________, NAMED('DENORMALIZE_RIGHT_OUTER')),
           OUTPUT(deno____ROU____xs__, NAMED('DENORMALIZE_RIGHT_OUTER_XFMSKIP')),
           OUTPUT(deno____ROU_ls_____, NAMED('DENORMALIZE_RIGHT_OUTER_LIMITSKIP')),
           OUTPUT(deno____ROU_ls_xs__, NAMED('DENORMALIZE_RIGHT_OUTER_LIMITSKIP_XFMSKIP')),
           OUTPUT(deno____ROU_lo_____, NAMED('DENORMALIZE_RIGHT_OUTER_LIMITONFAIL')),
           OUTPUT(deno____ROU_lo_xs__, NAMED('DENORMALIZE_RIGHT_OUTER_LIMITONFAIL_XFMSKIP')),
           OUTPUT(deno____RON________, NAMED('DENORMALIZE_RIGHT_ONLY')),
           OUTPUT(deno____RON____xs__, NAMED('DENORMALIZE_RIGHT_ONLY_XFMSKIP')),
           OUTPUT(deno____FOU________, NAMED('DENORMALIZE_FULL_OUTER')),
           OUTPUT(deno____FOU____xs__, NAMED('DENORMALIZE_FULL_OUTER_XFMSKIP')),
           OUTPUT(deno____FOU_ls_____, NAMED('DENORMALIZE_FULL_OUTER_LIMITSKIP')),
           OUTPUT(deno____FOU_ls_xs__, NAMED('DENORMALIZE_FULL_OUTER_LIMITSKIP_XFMSKIP')),
           OUTPUT(deno____FOU_lo_____, NAMED('DENORMALIZE_FULL_OUTER_LIMITONFAIL')),
           OUTPUT(deno____FOU_lo_xs__, NAMED('DENORMALIZE_FULL_OUTER_LIMITONFAIL_XFMSKIP')),
           OUTPUT(deno____FON________, NAMED('DENORMALIZE_FULL_ONLY')),
           OUTPUT(deno____FON____xs__, NAMED('DENORMALIZE_FULL_ONLY_XFMSKIP')),
           OUTPUT(deno_l1_INN________, NAMED('DENORMALIZE_LOOKUP')),
           OUTPUT(deno_l1_INN____xs__, NAMED('DENORMALIZE_LOOKUP_XFMSKIP')),
           OUTPUT(deno_l1_LOU________, NAMED('DENORMALIZE_LOOKUP_LEFT_OUTER')),
           OUTPUT(deno_l1_LOU____xs__, NAMED('DENORMALIZE_LOOKUP_LEFT_OUTER_XFMSKIP')),
           OUTPUT(deno_l1_LON________, NAMED('DENORMALIZE_LOOKUP_LEFT_ONLY')),
           OUTPUT(deno_l1_LON____xs__, NAMED('DENORMALIZE_LOOKUP_LEFT_ONLY_XFMSKIP')),
           OUTPUT(deno_lm_INN________, NAMED('DENORMALIZE_LOOKUP_MANY')),
           OUTPUT(deno_lm_INN____xs__, NAMED('DENORMALIZE_LOOKUP_MANY_XFMSKIP')),
           OUTPUT(deno_lm_INN_kp_____, NAMED('DENORMALIZE_LOOKUP_MANY_KEEP')),
           OUTPUT(deno_lm_INN_kp_xs__, NAMED('DENORMALIZE_LOOKUP_MANY_KEEP_XFMSKIP')),
           OUTPUT(deno_lm_INN_at_____, NAMED('DENORMALIZE_LOOKUP_MANY_ATMOST')),
           OUTPUT(deno_lm_INN_at_xs__, NAMED('DENORMALIZE_LOOKUP_MANY_ATMOST_XFMSKIP')),
           OUTPUT(deno_lm_INN_ls_____, NAMED('DENORMALIZE_LOOKUP_MANY_LIMITSKIP')),
           OUTPUT(deno_lm_INN_ls_xs__, NAMED('DENORMALIZE_LOOKUP_MANY_LIMITSKIP_XFMSKIP')),
           OUTPUT(deno_lm_INN_lo_____, NAMED('DENORMALIZE_LOOKUP_MANY_LIMITONFAIL')),
           OUTPUT(deno_lm_INN_lo_xs__, NAMED('DENORMALIZE_LOOKUP_MANY_LIMITONFAIL_XFMSKIP')),
           OUTPUT(deno_lm_LOU________, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER')),
           OUTPUT(deno_lm_LOU____xs__, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_XFMSKIP')),
           OUTPUT(deno_lm_LOU_kp_____, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_KEEP')),
           OUTPUT(deno_lm_LOU_kp_xs__, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_KEEP_XFMSKIP')),
           OUTPUT(deno_lm_LOU_at_____, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_ATMOST')),
           OUTPUT(deno_lm_LOU_at_xs__, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_ATMOST_XFMSKIP')),
           OUTPUT(deno_lm_LOU_ls_____, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP')),
           OUTPUT(deno_lm_LOU_ls_xs__, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP')),
           OUTPUT(deno_lm_LOU_lo_____, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL')),
           OUTPUT(deno_lm_LOU_lo_xs__, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP')),
           OUTPUT(deno_lm_LON________, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_ONLY')),
           OUTPUT(deno_lm_LON____xs__, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_XFMSKIP')),
           OUTPUT(deno_lm_LON_at_____, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_ATMOST')),
           OUTPUT(deno_lm_LON_at_xs__, NAMED('DENORMALIZE_LOOKUP_MANY_LEFT_ONLY_ATMOST_XFMSKIP')),
           OUTPUT(deno_al_INN________, NAMED('DENORMALIZE_ALL')),
           OUTPUT(deno_al_INN____xs__, NAMED('DENORMALIZE_ALL_XFMSKIP')),
           OUTPUT(deno_al_INN_kp_____, NAMED('DENORMALIZE_ALL_KEEP')),
           OUTPUT(deno_al_INN_kp_xs__, NAMED('DENORMALIZE_ALL_KEEP_XFMSKIP')),
           OUTPUT(deno_al_LOU________, NAMED('DENORMALIZE_ALL_LEFT_OUTER')),
           OUTPUT(deno_al_LOU____xs__, NAMED('DENORMALIZE_ALL_LEFT_OUTER_XFMSKIP')),
           OUTPUT(deno_al_LOU_kp_____, NAMED('DENORMALIZE_ALL_LEFT_OUTER_KEEP')),
           OUTPUT(deno_al_LOU_kp_xs__, NAMED('DENORMALIZE_ALL_LEFT_OUTER_KEEP_XFMSKIP')),
           OUTPUT(deno_al_LON________, NAMED('DENORMALIZE_ALL_LEFT_ONLY')),
           OUTPUT(deno_al_LON____xs__, NAMED('DENORMALIZE_ALL_LEFT_ONLY_XFMSKIP')),
           OUTPUT(dngr____INN________, NAMED('DENORMALIZEGROUP')),
           OUTPUT(dngr____INN____xs__, NAMED('DENORMALIZEGROUP_XFMSKIP')),
           OUTPUT(dngr____INN_kp_____, NAMED('DENORMALIZEGROUP_KEEP')),
           OUTPUT(dngr____INN_kp_xs__, NAMED('DENORMALIZEGROUP_KEEP_XFMSKIP')),
           OUTPUT(dngr____INN_at_____, NAMED('DENORMALIZEGROUP_ATMOST')),
           OUTPUT(dngr____INN_at_xs__, NAMED('DENORMALIZEGROUP_ATMOST_XFMSKIP')),
           OUTPUT(dngr____INN_ls_____, NAMED('DENORMALIZEGROUP_LIMITSKIP')),
           OUTPUT(dngr____INN_ls_xs__, NAMED('DENORMALIZEGROUP_LIMITSKIP_XFMSKIP')),
           OUTPUT(dngr____INN_lo_____, NAMED('DENORMALIZEGROUP_LIMITONFAIL')),
           OUTPUT(dngr____INN_lo_xs__, NAMED('DENORMALIZEGROUP_LIMITONFAIL_XFMSKIP')),
           OUTPUT(dngr____LOU________, NAMED('DENORMALIZEGROUP_LEFT_OUTER')),
           OUTPUT(dngr____LOU____xs__, NAMED('DENORMALIZEGROUP_LEFT_OUTER_XFMSKIP')),
           OUTPUT(dngr____LOU_kp_____, NAMED('DENORMALIZEGROUP_LEFT_OUTER_KEEP')),
           OUTPUT(dngr____LOU_kp_xs__, NAMED('DENORMALIZEGROUP_LEFT_OUTER_KEEP_XFMSKIP')),
           OUTPUT(dngr____LOU_at_____, NAMED('DENORMALIZEGROUP_LEFT_OUTER_ATMOST')),
           OUTPUT(dngr____LOU_at_xs__, NAMED('DENORMALIZEGROUP_LEFT_OUTER_ATMOST_XFMSKIP')),
           OUTPUT(dngr____LOU_ls_____, NAMED('DENORMALIZEGROUP_LEFT_OUTER_LIMITSKIP')),
           OUTPUT(dngr____LOU_ls_xs__, NAMED('DENORMALIZEGROUP_LEFT_OUTER_LIMITSKIP_XFMSKIP')),
           OUTPUT(dngr____LOU_lo_____, NAMED('DENORMALIZEGROUP_LEFT_OUTER_LIMITONFAIL')),
           OUTPUT(dngr____LOU_lo_xs__, NAMED('DENORMALIZEGROUP_LEFT_OUTER_LIMITONFAIL_XFMSKIP')),
           OUTPUT(dngr____LON________, NAMED('DENORMALIZEGROUP_LEFT_ONLY')),
           OUTPUT(dngr____LON____xs__, NAMED('DENORMALIZEGROUP_LEFT_ONLY_XFMSKIP')),
           OUTPUT(dngr____LON_at_____, NAMED('DENORMALIZEGROUP_LEFT_ONLY_ATMOST')),
           OUTPUT(dngr____LON_at_xs__, NAMED('DENORMALIZEGROUP_LEFT_ONLY_ATMOST_XFMSKIP')),
           OUTPUT(dngr____ROU________, NAMED('DENORMALIZEGROUP_RIGHT_OUTER')),
           OUTPUT(dngr____ROU____xs__, NAMED('DENORMALIZEGROUP_RIGHT_OUTER_XFMSKIP')),
           OUTPUT(dngr____ROU_ls_____, NAMED('DENORMALIZEGROUP_RIGHT_OUTER_LIMITSKIP')),
           OUTPUT(dngr____ROU_ls_xs__, NAMED('DENORMALIZEGROUP_RIGHT_OUTER_LIMITSKIP_XFMSKIP')),
           OUTPUT(dngr____ROU_lo_____, NAMED('DENORMALIZEGROUP_RIGHT_OUTER_LIMITONFAIL')),
           OUTPUT(dngr____ROU_lo_xs__, NAMED('DENORMALIZEGROUP_RIGHT_OUTER_LIMITONFAIL_XFMSKIP')),
           OUTPUT(dngr____RON________, NAMED('DENORMALIZEGROUP_RIGHT_ONLY')),
           OUTPUT(dngr____RON____xs__, NAMED('DENORMALIZEGROUP_RIGHT_ONLY_XFMSKIP')),
           OUTPUT(dngr____FOU________, NAMED('DENORMALIZEGROUP_FULL_OUTER')),
           OUTPUT(dngr____FOU____xs__, NAMED('DENORMALIZEGROUP_FULL_OUTER_XFMSKIP')),
           OUTPUT(dngr____FOU_ls_____, NAMED('DENORMALIZEGROUP_FULL_OUTER_LIMITSKIP')),
           OUTPUT(dngr____FOU_ls_xs__, NAMED('DENORMALIZEGROUP_FULL_OUTER_LIMITSKIP_XFMSKIP')),
           OUTPUT(dngr____FOU_lo_____, NAMED('DENORMALIZEGROUP_FULL_OUTER_LIMITONFAIL')),
           OUTPUT(dngr____FOU_lo_xs__, NAMED('DENORMALIZEGROUP_FULL_OUTER_LIMITONFAIL_XFMSKIP')),
           OUTPUT(dngr____FON________, NAMED('DENORMALIZEGROUP_FULL_ONLY')),
           OUTPUT(dngr____FON____xs__, NAMED('DENORMALIZEGROUP_FULL_ONLY_XFMSKIP')),
           OUTPUT(dngr_l1_INN________, NAMED('DENORMALIZEGROUP_LOOKUP')),
           OUTPUT(dngr_l1_INN____xs__, NAMED('DENORMALIZEGROUP_LOOKUP_XFMSKIP')),
           OUTPUT(dngr_l1_LOU________, NAMED('DENORMALIZEGROUP_LOOKUP_LEFT_OUTER')),
           OUTPUT(dngr_l1_LOU____xs__, NAMED('DENORMALIZEGROUP_LOOKUP_LEFT_OUTER_XFMSKIP')),
           OUTPUT(dngr_l1_LON________, NAMED('DENORMALIZEGROUP_LOOKUP_LEFT_ONLY')),
           OUTPUT(dngr_l1_LON____xs__, NAMED('DENORMALIZEGROUP_LOOKUP_LEFT_ONLY_XFMSKIP')),
           OUTPUT(dngr_lm_INN________, NAMED('DENORMALIZEGROUP_LOOKUP_MANY')),
           OUTPUT(dngr_lm_INN____xs__, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_XFMSKIP')),
           OUTPUT(dngr_lm_INN_kp_____, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_KEEP')),
           OUTPUT(dngr_lm_INN_kp_xs__, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_KEEP_XFMSKIP')),
           OUTPUT(dngr_lm_INN_at_____, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_ATMOST')),
           OUTPUT(dngr_lm_INN_at_xs__, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_ATMOST_XFMSKIP')),
           OUTPUT(dngr_lm_INN_ls_____, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LIMITSKIP')),
           OUTPUT(dngr_lm_INN_ls_xs__, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LIMITSKIP_XFMSKIP')),
           OUTPUT(dngr_lm_INN_lo_____, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LIMITONFAIL')),
           OUTPUT(dngr_lm_INN_lo_xs__, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LIMITONFAIL_XFMSKIP')),
           OUTPUT(dngr_lm_LOU________, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER')),
           OUTPUT(dngr_lm_LOU____xs__, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_XFMSKIP')),
           OUTPUT(dngr_lm_LOU_kp_____, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_KEEP')),
           OUTPUT(dngr_lm_LOU_kp_xs__, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_KEEP_XFMSKIP')),
           OUTPUT(dngr_lm_LOU_at_____, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_ATMOST')),
           OUTPUT(dngr_lm_LOU_at_xs__, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_ATMOST_XFMSKIP')),
           OUTPUT(dngr_lm_LOU_ls_____, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP')),
           OUTPUT(dngr_lm_LOU_ls_xs__, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITSKIP_XFMSKIP')),
           OUTPUT(dngr_lm_LOU_lo_____, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL')),
           OUTPUT(dngr_lm_LOU_lo_xs__, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_OUTER_LIMITONFAIL_XFMSKIP')),
           OUTPUT(dngr_lm_LON________, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY')),
           OUTPUT(dngr_lm_LON____xs__, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_XFMSKIP')),
           OUTPUT(dngr_lm_LON_at_____, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_ATMOST')),
           OUTPUT(dngr_lm_LON_at_xs__, NAMED('DENORMALIZEGROUP_LOOKUP_MANY_LEFT_ONLY_ATMOST_XFMSKIP')),
           OUTPUT(dngr_al_INN________, NAMED('DENORMALIZEGROUP_ALL')),
           OUTPUT(dngr_al_INN____xs__, NAMED('DENORMALIZEGROUP_ALL_XFMSKIP')),
           OUTPUT(dngr_al_INN_kp_____, NAMED('DENORMALIZEGROUP_ALL_KEEP')),
           OUTPUT(dngr_al_INN_kp_xs__, NAMED('DENORMALIZEGROUP_ALL_KEEP_XFMSKIP')),
           OUTPUT(dngr_al_LOU________, NAMED('DENORMALIZEGROUP_ALL_LEFT_OUTER')),
           OUTPUT(dngr_al_LOU____xs__, NAMED('DENORMALIZEGROUP_ALL_LEFT_OUTER_XFMSKIP')),
           OUTPUT(dngr_al_LOU_kp_____, NAMED('DENORMALIZEGROUP_ALL_LEFT_OUTER_KEEP')),
           OUTPUT(dngr_al_LOU_kp_xs__, NAMED('DENORMALIZEGROUP_ALL_LEFT_OUTER_KEEP_XFMSKIP')),
           OUTPUT(dngr_al_LON________, NAMED('DENORMALIZEGROUP_ALL_LEFT_ONLY')),
           OUTPUT(dngr_al_LON____xs__, NAMED('DENORMALIZEGROUP_ALL_LEFT_ONLY_XFMSKIP')));
